// DialogView.cpp : implementation file
//

#include "stdafx.h"
#include "OpenGL View Class.h"
#include "DialogView.h"
#include "OpenGL View ClassDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#define BEZSCALE 40
/////////////////////////////////////////////////////////////////////////////
// CDialogView

IMPLEMENT_DYNCREATE(CDialogView, CScrollView)

CDialogView::CDialogView()
{
  m_pointMouse = CPoint(0,0);
  m_bCaptured = FALSE;
  m_cap = -1;
}

CDialogView::~CDialogView()
{
}


BEGIN_MESSAGE_MAP(CDialogView, CScrollView)
	//{{AFX_MSG_MAP(CDialogView)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDialogView drawing

void CDialogView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();
	CSize sizeTotal(300*2, 300*2);
	CSize sizePage(sizeTotal.cx/2,sizeTotal.cy/2);
	CSize sizeLine(sizeTotal.cx/50,sizeTotal.cy/50);
	SetScrollSizes(MM_LOENGLISH, sizeTotal,sizePage,sizeLine);
}


BOOL CDialogView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

void CDialogView::OnDraw(CDC* pDC)
{
  float out[2];

  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
	
  for (int i=0; i < 6; i++) {
    float x =  (pDoc->GetXCoor(i) * BEZSCALE) + 300;
    float y =  (pDoc->GetYCoor(i) * BEZSCALE) - 300;
    m_rect[i].SetRect(x-5, y-5, x+5, y+5);
    //	  m_rect[i].NormalizeRect();
    pDC->Rectangle(m_rect[i]);
  }
	
  pDC->MoveTo(-3*BEZSCALE+300, 0*BEZSCALE-300);
  pDC->LineTo(3*BEZSCALE+300, 0*BEZSCALE-300);

  pDC->MoveTo(0*BEZSCALE+300, 3*BEZSCALE-300);
  pDC->LineTo(0*BEZSCALE+300, -3*BEZSCALE-300);

  CPen pen(PS_SOLID, 1, RGB(255,0,0));
  CPen *pOldPen = pDC->SelectObject (&pen);

  pDC->MoveTo((pDoc->GetXCoor(0))*BEZSCALE+300,(pDoc->GetYCoor(0))*BEZSCALE-300);
	
  for (int j=0; j<=50; j++) {
    CalPos(pDoc, (float) j/50, out, TRUE);
    pDC->LineTo(out[0]*BEZSCALE+300,out[1]*BEZSCALE-300);
    pDC->MoveTo(out[0]*BEZSCALE+300,out[1]*BEZSCALE-300);
  }

  for(int k=0; k<=50; k++) {
    CalPos(pDoc, (float) k/50, out, FALSE);
    pDC->LineTo(out[0]*BEZSCALE+300,out[1]*BEZSCALE-300);
    pDC->MoveTo(out[0]*BEZSCALE+300,out[1]*BEZSCALE-300);
  }

  pDC->SelectObject (pOldPen);

}


void CDialogView::CalPos(COpenGLViewClassDoc *pDoc, float pos, float *output,
			 BOOL first)
{
  if (first) {

    output[0] = (pDoc->GetXCoor(0))*(1-pos)*(1-pos)*(1-pos) +
                (pDoc->GetXCoor(1))*3*pos*(1-pos)*(1-pos) +
                (pDoc->GetXCoor(2))*3*pos*pos*(1-pos)+
                (pDoc->GetXCoor(3))*pos*pos*pos;
    
    output[1] = (pDoc->GetYCoor(0))*(1-pos)*(1-pos)*(1-pos) +
                (pDoc->GetYCoor(1))*3*pos*(1-pos)*(1-pos) +
                (pDoc->GetYCoor(2))*3*pos*pos*(1-pos)+
                (pDoc->GetYCoor(3))*pos*pos*pos;
  } else {
    output[0] = (pDoc->GetXCoor(3))*(1-pos)*(1-pos)*(1-pos) +
                (pDoc->GetXCoor(4))*3*pos*(1-pos)*(1-pos) +
                (pDoc->GetXCoor(5))*3*pos*pos*(1-pos)+
                (pDoc->GetXCoor(0))*pos*pos*pos;
    
    output[1] = (pDoc->GetYCoor(3))*(1-pos)*(1-pos)*(1-pos) +
                (pDoc->GetYCoor(4))*3*pos*(1-pos)*(1-pos) +
                (pDoc->GetYCoor(5))*3*pos*pos*(1-pos)+
                (pDoc->GetYCoor(0))*pos*pos*pos;

  }
}
/////////////////////////////////////////////////////////////////////////////
// CDialogView diagnostics

#ifdef _DEBUG
void CDialogView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CDialogView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

COpenGLViewClassDoc* CDialogView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(COpenGLViewClassDoc)));
	return (COpenGLViewClassDoc*)m_pDocument;
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDialogView message handlers

void CDialogView::OnLButtonDown(UINT nFlags, CPoint point) 
{
  CClientDC dc(this);
  OnPrepareDC(&dc);
  dc.DPtoLP (&point);

  for(int i=0; i<6;i++) {
    if (m_rect[i].PtInRect(point)) {
      //      MessageBox("You clicked it!");
      SetCapture();
      m_bCaptured = TRUE;
      m_cap = i;
      //      dc.DPtoLP(&point);
      m_pointMouse = point;
      ::SetCursor(::LoadCursor(NULL, IDC_CROSS));
    }

  }

}

void CDialogView::OnLButtonUp(UINT nFlags, CPoint point) 
{
  if (m_bCaptured) {
    ::ReleaseCapture();
    m_bCaptured = FALSE;
    m_cap = -1;
  }
}

void CDialogView::OnMouseMove(UINT nFlags, CPoint point) 
{
  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);

  CSize sizeOffset;
  CPoint pointMouse; 
  CRect rectOld;
  CRect rectNew;
  CClientDC dc(this);
  OnPrepareDC(&dc);
  
  if (m_bCaptured) {
    rectOld = m_rect[m_cap];
    pointMouse = m_pointMouse;
    dc.LPtoDP(rectOld); 
    InvalidateRect(rectOld,TRUE);

    dc.LPtoDP(&pointMouse);
    sizeOffset = point - pointMouse;
    rectNew = rectOld + (CPoint(0,0) + sizeOffset);
    InvalidateRect(rectNew,TRUE);
    InvalidateRect(0,FALSE);
    dc.DPtoLP(&point);
    dc.DPtoLP(rectNew);
    m_pointMouse = point;
    m_rect[m_cap] = rectNew; 
    pDoc->AddPoint(m_cap, (float)(point.x-300)/BEZSCALE,
		   (float)(point.y+300)/BEZSCALE);

  }

}
