// ShellDialog.cpp : implementation file
//

#include "stdafx.h"
#include "OpenGL View Class.h"
#include "ShellDialog.h"
#include "COpenGLView.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// ShellDialog dialog


ShellDialog::ShellDialog(CWnd* pParent /*=NULL*/)
	: CDialog(ShellDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(ShellDialog)
	m_solid = -1;
	m_smooth = -1;
	m_lightinit = FALSE;
	m_spinx = 0.0;
	m_spiny = 0.0f;
	m_spinz = 0.0f;
	m_loopinit = FALSE;
	m_initp = 0;
	m_sping = 0;
	m_spinb = 0;
	m_spinr = 0;
	m_scalex = 0.0f;
	m_scaley = 0.0f;
	m_scalez = 0.0f;
	m_revolution = 0;
	m_initr = 0.0f;
	m_initz = 0.0f;
	m_lamdar = 0.0f;
	m_increment = 0;
	m_matinit = FALSE;
	//}}AFX_DATA_INIT
}

ShellDialog::ShellDialog(COpenGLView *pView)
{
  m_pView = pView;
}

BOOL ShellDialog::Create()
{
  return CDialog::Create(ShellDialog::IDD);
}
void ShellDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(ShellDialog)
	DDX_Control(pDX, IDC_BUDDYR, m_editr);
	DDX_Control(pDX, IDC_BUDDYG, m_editg);
	DDX_Control(pDX, IDC_BUDDYB, m_editb);
	DDX_Control(pDX, IDC_MATCHECK, m_matcheck);
	DDX_Control(pDX, IDC_EDITINCREMENT, m_editincrement);
	DDX_Control(pDX, IDC_EDITLAMDAR, m_editlamdar);
	DDX_Control(pDX, IDC_EDITINITZ, m_editinitz);
	DDX_Control(pDX, IDC_EDITINITR, m_editinitr);
	DDX_Control(pDX, IDC_EDITREVOLUTION, m_editrevolution);
	DDX_Control(pDX, IDC_EDITSCALEZ, m_editscalez);
	DDX_Control(pDX, IDC_EDITSCALEY, m_editscaley);
	DDX_Control(pDX, IDC_EDITSCALEX, m_editscalex);
	DDX_Control(pDX, IDC_EDITPOINT, m_editpoint);
	DDX_Control(pDX, IDC_LOOPCHECK, m_loopcheck);
	DDX_Control(pDX, IDC_EDITZ, m_editz);
	DDX_Control(pDX, IDC_EDITY, m_edity);
	DDX_Control(pDX, IDC_EDITX, m_editx);
	DDX_Control(pDX, IDC_CHECK1, m_lightcheck);
	DDX_Control(pDX, IDC_REVUP, m_revup);
	DDX_Control(pDX, IDC_REVDOWN, m_revdown);
	DDX_Radio(pDX, IDC_SOLID, m_solid);
	DDX_Radio(pDX, IDC_SMOOTH, m_smooth);
	DDX_Check(pDX, IDC_CHECK1, m_lightinit);
	DDX_Text(pDX, IDC_EDITX, m_spinx);
	DDX_Text(pDX, IDC_EDITY, m_spiny);
	DDX_Text(pDX, IDC_EDITZ, m_spinz);
	DDX_Check(pDX, IDC_LOOPCHECK, m_loopinit);
	DDX_Text(pDX, IDC_EDITPOINT, m_initp);
	DDV_MinMaxInt(pDX, m_initp, 2, 100);
	DDX_Text(pDX, IDC_BUDDYG, m_sping);
	DDV_MinMaxInt(pDX, m_sping, 0, 100);
	DDX_Text(pDX, IDC_BUDDYB, m_spinb);
	DDV_MinMaxInt(pDX, m_spinb, 0, 100);
	DDX_Text(pDX, IDC_BUDDYR, m_spinr);
	DDV_MinMaxInt(pDX, m_spinr, 0, 100);
	DDX_Text(pDX, IDC_EDITSCALEX, m_scalex);
	DDX_Text(pDX, IDC_EDITSCALEY, m_scaley);
	DDX_Text(pDX, IDC_EDITSCALEZ, m_scalez);
	DDX_Text(pDX, IDC_EDITREVOLUTION, m_revolution);
	DDV_MinMaxInt(pDX, m_revolution, -50, 50);
	DDX_Text(pDX, IDC_EDITINITR, m_initr);
	DDX_Text(pDX, IDC_EDITINITZ, m_initz);
	DDX_Text(pDX, IDC_EDITLAMDAR, m_lamdar);
	DDX_Text(pDX, IDC_EDITINCREMENT, m_increment);
	DDX_Check(pDX, IDC_MATCHECK, m_matinit);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(ShellDialog, CDialog)
	//{{AFX_MSG_MAP(ShellDialog)
	ON_BN_CLICKED(IDC_REVDOWN, OnRevdown)
	ON_BN_CLICKED(IDC_REVUP, OnRevup)
	ON_BN_CLICKED(IDC_SMOOTH, OnSmooth)
	ON_BN_CLICKED(IDC_RADIO2, OnFlat)
	ON_BN_CLICKED(IDC_CHECK1, OnLight)
	ON_BN_CLICKED(IDC_SOLID, OnSolid)
	ON_BN_CLICKED(IDC_RADIO4, OnWireframe)
	ON_WM_VSCROLL()
	ON_BN_CLICKED(IDC_BUTX, OnButx)
	ON_BN_CLICKED(IDC_BUTY, OnButy)
	ON_BN_CLICKED(IDC_BUTZ, OnButz)
	ON_BN_CLICKED(IDC_LOOPCHECK, OnLoopcheck)
	ON_BN_CLICKED(IDC_BUTPOINT, OnButpoint)
	ON_BN_CLICKED(IDC_BUTINITR, OnButinitr)
	ON_BN_CLICKED(IDC_BUTINITZ, OnButinitz)
	ON_BN_CLICKED(IDC_BUTLAMDAR, OnButlamdar)
	ON_BN_CLICKED(IDC_BUTREVOLUTION, OnButrevolution)
	ON_BN_CLICKED(IDC_BUTSCALEX, OnButscalex)
	ON_BN_CLICKED(IDC_BUTSCALEY, OnButscaley)
	ON_BN_CLICKED(IDC_BUTSCALEZ, OnButscalez)
	ON_BN_CLICKED(IDC_BUTINCREMENT, OnButincrement)
	ON_BN_CLICKED(IDC_MATCHECK, OnMatcheck)
	ON_BN_CLICKED(IDC_BUTGREEN, OnButgreen)
	ON_BN_CLICKED(IDC_BUTBLUE, OnButblue)
	ON_BN_CLICKED(IDC_BUTRED, OnButred)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ShellDialog message handlers


void ShellDialog::OnRevdown() 
{
	// TODO: Add your control notification handler code here
  m_pView->RevDown();
	
}

void ShellDialog::OnRevup() 
{
	// TODO: Add your control notification handler code here
  m_pView->RevUp();
	
}

void ShellDialog::OnOK()
{
  UpdateData(TRUE);
  return;
}


void ShellDialog::OnSmooth() 
{
	// TODO: Add your control notification handler code here
	
	m_pView->SetSmooth(TRUE);
	
}

void ShellDialog::OnFlat() 
{
	// TODO: Add your control notification handler code here

	m_pView->SetSmooth(FALSE);
	
}

void ShellDialog::OnLight() 
{
	// TODO: Add your control notification handler code here
	if (m_lightcheck.GetCheck())
		m_pView->SetLight(TRUE);
	else
		m_pView->SetLight(FALSE);
}

void ShellDialog::OnSolid() 
{
	// TODO: Add your control notification handler code here
	m_pView->SetSolid(TRUE);
}

void ShellDialog::OnWireframe() 
{
	// TODO: Add your control notification handler code here
	m_pView->SetSolid(FALSE);
}

BOOL ShellDialog::OnInitDialog() 
{
  /*	CSpinButtonCtrl *pSpinX = (CSpinButtonCtrl *) GetDlgItem(IDC_SPINPOINTS);
	CSpinButtonCtrl *pSpinY = (CSpinButtonCtrl *) GetDlgItem(IDC_SPINY);
	CSpinButtonCtrl *pSpinZ = (CSpinButtonCtrl *) GetDlgItem(IDC_SPINZ);

	pSpinX->SetRange(0,100);

	pSpinX->SetPos((int) (m_dxspin+20.0) * 2.5);

	pSpinY->SetRange(0,100);

	pSpinY->SetPos((int) (m_dyspin+20.0) * 2.5);

	pSpinZ->SetRange(0,100);

	pSpinZ->SetPos((int) (m_dzspin+20.0) * 2.5);  */


        CSpinButtonCtrl *pSpinPoints = (CSpinButtonCtrl *) GetDlgItem(IDC_SPINPOINTS);
        CSpinButtonCtrl *pSpinRevolution = (CSpinButtonCtrl *) GetDlgItem(IDC_SPINREVOLUTION);
        CSpinButtonCtrl *pSpinIncrement = (CSpinButtonCtrl *) GetDlgItem(IDC_SPININCREMENT);

        CSpinButtonCtrl *pSpinR = (CSpinButtonCtrl *) GetDlgItem(IDC_SPINR);
        CSpinButtonCtrl *pSpinG = (CSpinButtonCtrl *) GetDlgItem(IDC_SPING);
        CSpinButtonCtrl *pSpinB = (CSpinButtonCtrl *) GetDlgItem(IDC_SPINB);

	pSpinR->SetRange(0,100);
	pSpinG->SetRange(0,100);
	pSpinB->SetRange(0,100);

	pSpinPoints->SetRange(2,100);
	pSpinRevolution->SetRange(-50,50);
	pSpinIncrement->SetRange(1,100);

	m_solid = 0;
	m_smooth= 0;
	m_lightinit = TRUE;
	m_loopinit = TRUE;
	m_spinx = 0.0;
	m_spiny = 0.0;
	m_spinz = 10.0;
	m_initp = 5;
	m_spinr = 100;
	m_sping = 0;
	m_spinb = 0;
	m_revolution = 3;
	m_initr = 0.4f;
	m_initz = -1.0f;
	m_lamdar = 1.007f;
	m_increment = 12;
	m_scalex = 1.013f;
	m_scaley = 1.013f;
	m_scalez = 1.013f;
	m_matinit = FALSE;

	CDialog::OnInitDialog();
	
	
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void ShellDialog::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}


void ShellDialog::OnButx() 
{
	// TODO: Add your control notification handler code here
	
	CString val;
	m_editx.GetWindowText(val);
	m_pView->SetCamX((float)atof(val.GetBuffer(7)));
	
	
}

void ShellDialog::OnButy() 
{
	// TODO: Add your control notification handler code here
	
	CString val;
	m_edity.GetWindowText(val);
	m_pView->SetCamY((float)atof(val.GetBuffer(7)));
	
}

void ShellDialog::OnButz() 
{
	// TODO: Add your control notification handler code here
	
	CString val;
	m_editz.GetWindowText(val);
	m_pView->SetCamZ((float)atof(val.GetBuffer(7)));
	
}

void ShellDialog::OnLoopcheck() 
{
	// TODO: Add your control notification handler code here
	if (m_loopcheck.GetCheck())
		m_pView->SetLoop(TRUE);
	else
		m_pView->SetLoop(FALSE);
}

void ShellDialog::OnButpoint() 
{
	CString val;
	m_editpoint.GetWindowText(val);
	m_pView->SetPoints((int) atoi(val.GetBuffer(7)));
	// TODO: Add your control notification handler code here
	
}

void ShellDialog::OnButinitr() 
{
	// TODO: Add your control notification handler code here
	CString val;
	m_editinitr.GetWindowText(val);
	m_pView->SetInitr((float)atof(val.GetBuffer(7)));
	
}

void ShellDialog::OnButinitz() 
{
	// TODO: Add your control notification handler code here
	CString val;
	m_editinitz.GetWindowText(val);
	m_pView->SetInitz((float)atof(val.GetBuffer(7)));
	
}

void ShellDialog::OnButlamdar() 
{
	// TODO: Add your control notification handler code here
	CString val;
	m_editlamdar.GetWindowText(val);
	m_pView->SetLamdar((float)atof(val.GetBuffer(7)));
	
}

void ShellDialog::OnButrevolution() 
{
	// TODO: Add your control notification handler code here
	CString val;
	m_editrevolution.GetWindowText(val);
	m_pView->SetRevolution((int)atoi(val.GetBuffer(7)));
	
}

void ShellDialog::OnButscalex() 
{
	// TODO: Add your control notification handler code here
	CString val;
	m_editscalex.GetWindowText(val);
	m_pView->SetScalex((float)atof(val.GetBuffer(7)));
	
}

void ShellDialog::OnButscaley() 
{
	// TODO: Add your control notification handler code here
	CString val;
	m_editscaley.GetWindowText(val);
	m_pView->SetScaley((float)atof(val.GetBuffer(7)));
	
}

void ShellDialog::OnButscalez() 
{
	// TODO: Add your control notification handler code here
	CString val;
	m_editscalez.GetWindowText(val);
	m_pView->SetScalez((float)atof(val.GetBuffer(7)));
	
}

void ShellDialog::OnButincrement() 
{
	// TODO: Add your control notification handler code here
	CString val;
	m_editincrement.GetWindowText(val);
	m_pView->SetIncrement((int)atoi(val.GetBuffer(7)));
	
}

void ShellDialog::OnMatcheck() 
{
  if (m_matcheck.GetCheck())
    m_pView->SetMat(TRUE);
  else
    m_pView->SetMat(FALSE);
}

void ShellDialog::OnButgreen() 
{
	CString val;
	m_editg.GetWindowText(val);
	m_pView->SetGreen((int)atoi(val.GetBuffer(7)));
	
}

void ShellDialog::OnButblue() 
{
	CString val;
	m_editb.GetWindowText(val);
	m_pView->SetBlue((int)atoi(val.GetBuffer(7)));
	
}

void ShellDialog::OnButred() 
{
	CString val;
	m_editr.GetWindowText(val);
	m_pView->SetRed((int)atoi(val.GetBuffer(7)));
	
}

