// COpenGLView.cpp : implementation of the COpenGLView class
//

#include "stdafx.h"
#include "OpenGL View Class.h"

#include "OpenGL View ClassDoc.h"
#include "COpenGLView.h"
#include "ShellDialog.h"
#include "ShDialog.h"
#include <math.h>
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define PI 3.141592654
const char* const COpenGLView::_ErrorStrings[]= {
				{"No Error"},					// 0
				{"Unable to get a DC"},			// 1
				{"ChoosePixelFormat failed"},	// 2
				{"SelectPixelFormat failed"},	// 3
				{"wglCreateContext failed"},	// 4
				{"wglMakeCurrent failed"},		// 5
				{"wglDeleteContext failed"},	// 6
				{"SwapBuffers failed"},			// 7

		};
/*
static GLfloat ir = 1.007;
static GLfloat iz = -1.0; 

static int ic = 12;
static GLfloat localscale = 1.013;
static GLfloat initi = 0.4;
*/
static int tf = 0;


/////////////////////////////////////////////////////////////////////////////
// COpenGLView

void myinit();

IMPLEMENT_DYNCREATE(COpenGLView, CView)

BEGIN_MESSAGE_MAP(COpenGLView, CView)
	//{{AFX_MSG_MAP(COpenGLView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_ERASEBKGND()
	ON_WM_SIZE()
 	ON_WM_KEYDOWN()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COpenGLView construction/destruction

COpenGLView::COpenGLView() :
	 m_hRC(0), m_pDC(0), m_ErrorString(_ErrorStrings[0])

{
	// TODO: add construction code here
  m_pDlg = new ShellDialog(this);
  m_rotex = 0.0;
  m_rotey = 0.0;
  m_rotez = 0.0;
}



COpenGLView::~COpenGLView()
{
  delete m_pDlg;
}

BOOL COpenGLView::PreCreateWindow(CREATESTRUCT& cs) 
{
	// TODO: Add your specialized code here and/or call the base class

	// An OpenGL window must be created with the following flags and must not
    // include CS_PARENTDC for the class style. 
    cs.style |= WS_CLIPSIBLINGS | WS_CLIPCHILDREN;
  	
	return CView::PreCreateWindow(cs);
}


/////////////////////////////////////////////////////////////////////////////
// COpenGLView drawing


void COpenGLView::OnDraw(CDC* pDC)
{
  /*	COpenGLViewClassDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc); */

	// TODO: add draw code for native data here

	::glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

	PreRenderScene();

	::glPushMatrix();
	//	RenderStockScene();
	::glPopMatrix();

	::glPushMatrix();
	RenderScene();
	::glPopMatrix();

	::glFinish();

	if ( FALSE == ::SwapBuffers( m_pDC->GetSafeHdc() ) )
		{
		SetError(7);
		}
}


/////////////////////////////////////////////////////////////////////////////
// COpenGLView diagnostics

#ifdef _DEBUG
void COpenGLView::AssertValid() const
{
	CView::AssertValid();
}

void COpenGLView::Dump(CDumpContext& dc) const
{ 
	CView::Dump(dc);
}

COpenGLViewClassDoc* COpenGLView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(COpenGLViewClassDoc)));
	return (COpenGLViewClassDoc*)m_pDocument;
}
#endif //_DEBUG

int COpenGLView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
  if (CView::OnCreate(lpCreateStruct) == -1)
    return -1;
	
  // TODO: Add your specialized creation code here

  InitializeOpenGL();

  return 0;
}


/////////////////////////////////////////////////////////////////////////////
// GL helper functions

void COpenGLView::SetError( int e )
{
  // if there was no previous error,
  // then save this one
  if ( _ErrorStrings[0] == m_ErrorString ) 
    {
      m_ErrorString = _ErrorStrings[e];
    }
}

void COpenGLView::SetSmooth(BOOL t)
{
  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
  if (t)
    pDoc->m_flat = FALSE;
  else
    pDoc->m_flat = TRUE;

  pDoc->SetModifiedFlag();
  OnDraw(m_pDC);

}

void COpenGLView::SetSolid(BOOL t)
{
  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
  if (t)
    pDoc->m_solid = GL_TRIANGLE_STRIP;
  else
    pDoc->m_solid = GL_LINE_STRIP;

  pDoc->SetModifiedFlag();
  OnDraw(m_pDC);

}

void COpenGLView::SetLight(BOOL t)
{
  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
  if (t)
    pDoc->m_light = TRUE;
  else
    pDoc->m_light = FALSE;

  pDoc->SetModifiedFlag();
  OnDraw(m_pDC);

}

void COpenGLView::SetLoop(BOOL t)
{
  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
  if (t)
    pDoc->m_loop = TRUE;
  else
    pDoc->m_loop = FALSE;

  pDoc->SetModifiedFlag();
  OnDraw(m_pDC);

}

void COpenGLView::SetMat(BOOL t)
{
  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
  if (t)
    pDoc->m_mat = TRUE;
  else
    pDoc->m_mat = FALSE;

  pDoc->SetModifiedFlag();
  OnDraw(m_pDC);

}

void COpenGLView::SetPoints(int t)
{
  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
  pDoc->m_points = t;
  pDoc->SetModifiedFlag();
  OnDraw(m_pDC);
}

void COpenGLView::SetCamX(float t)
{
  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
  pDoc->m_camFrom[0] = t;
  pDoc->SetModifiedFlag();
  OnDraw(m_pDC);
}


void COpenGLView::SetCamY(float t)
{
  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
  pDoc->m_camFrom[1] = t;
  pDoc->SetModifiedFlag();
  OnDraw(m_pDC);
}
void COpenGLView::SetCamZ(float t)
{
  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
  pDoc->m_camFrom[2] = t;
  pDoc->SetModifiedFlag();
  OnDraw(m_pDC);
}

void COpenGLView::RevUp()
{
  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
  pDoc->m_rev++;
  pDoc->SetModifiedFlag();
  OnDraw(m_pDC);
}

void COpenGLView::RevDown()
{
  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
  if (pDoc->m_rev > 0) {
    pDoc->m_rev--;
    pDoc->SetModifiedFlag();
    OnDraw(m_pDC);
  }
}

void COpenGLView::SetInitr(float t)
{
  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
  pDoc->m_initr = t;
  pDoc->SetModifiedFlag();
  OnDraw(m_pDC);
}
void COpenGLView::SetInitz(float t)
{
  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
  pDoc->m_initz = t;
  pDoc->SetModifiedFlag();
  OnDraw(m_pDC);
}
void COpenGLView::SetLamdar(float t)
{
  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
  pDoc->m_lamdar = t;
  pDoc->SetModifiedFlag();
  OnDraw(m_pDC);
}
void COpenGLView::SetRevolution(INT t)
{
  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
  if ((pDoc->m_rev + t) < 0)
    pDoc->m_rev = 0;
  else 
    pDoc->m_rev += t;
  pDoc->SetModifiedFlag();
  OnDraw(m_pDC);
}
void COpenGLView::SetScalex(float t)
{
  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
  
  pDoc->m_scalex = t;

  pDoc->SetModifiedFlag();
  OnDraw(m_pDC);
}
void COpenGLView::SetScaley(float t)
{
  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
  pDoc->m_scaley = t;
  pDoc->SetModifiedFlag();
  OnDraw(m_pDC);
}
void COpenGLView::SetScalez(float t)
{
  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
  pDoc->m_scalez = t;
  pDoc->SetModifiedFlag();
  OnDraw(m_pDC);
}
void COpenGLView::SetIncrement(INT t)
{
  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
  pDoc->m_increment = t;
  pDoc->SetModifiedFlag();
  OnDraw(m_pDC);
}

void COpenGLView::SetRed(INT t)
{
  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
  pDoc->m_spinr = t;
  pDoc->SetModifiedFlag();
  OnDraw(m_pDC);
}

void COpenGLView::SetGreen(INT t)
{
  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
  pDoc->m_sping = t;
  pDoc->SetModifiedFlag();
  OnDraw(m_pDC);
}

void COpenGLView::SetBlue(INT t)
{
  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
  pDoc->m_spinb = t;
  pDoc->SetModifiedFlag();
  OnDraw(m_pDC);
}

BOOL COpenGLView::InitializeOpenGL()
{
  // Can we put this in the constructor?
  m_pDC = new CClientDC(this);

  if ( NULL == m_pDC ) // failure to get DC
    {
      SetError(1);
      return FALSE;
    }

  if (!SetupPixelFormat())
    {
      return FALSE;
    }

  //n = ::GetPixelFormat(m_pDC->GetSafeHdc());
  //::DescribePixelFormat(m_pDC->GetSafeHdc(), n, sizeof(pfd), &pfd);

  //  CreateRGBPalette();

  if ( 0 == (m_hRC = ::wglCreateContext( m_pDC->GetSafeHdc() ) ) )
    {
      SetError(4);
      return FALSE;
    }

  if ( FALSE == ::wglMakeCurrent( m_pDC->GetSafeHdc(), m_hRC ) )
    {
      SetError(5);
      return FALSE;
    }	

  // specify black as clear color
  ::glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
  // specify the back of the buffer as clear depth
  ::glClearDepth(1.0f);
  // enable depth testing
  ::glEnable(GL_DEPTH_TEST);

  myinit();
  m_pDlg->Create();
  return TRUE;
}

void myMatMultRotY(GLfloat degree, GLfloat matrix[4][4])
{
  GLfloat tmpmat[4][4];
  int i, j;

  for (i = 0; i<4; i++)
    tmpmat[i][0] = matrix[i][0] * cos(degree/180*PI) + matrix[i][2] * sin(degree/180*PI);
  
  for (i =0; i< 4; i++)
    tmpmat[i][1] = matrix[i][1];


  for (i = 0; i<4; i++)
    tmpmat[i][2] = matrix[i][0] * -sin(degree/180*PI) + matrix[i][2] * cos(degree/180*PI);

  for (i =0; i< 4; i++)
    tmpmat[i][3] = matrix[i][3];

  for (i=0; i< 4; i++) 
    for (j=0; j<4; j++)
      matrix[i][j] = tmpmat[i][j];

}


void myMatMultRotX(GLfloat degree, GLfloat matrix[4][4])
{
  GLfloat tmpmat[4][4];
  int i, j;

  for (i =0; i< 4; i++)
    tmpmat[i][0] = matrix[i][0];

  for (i = 0; i<4; i++)
    tmpmat[i][1] = matrix[i][1] * cos(degree/180*PI) + matrix[i][2] * -sin(degree/180*PI);
  
  for (i = 0; i<4; i++)
    tmpmat[i][2] = matrix[i][1] * sin(degree/180*PI) + matrix[i][2] * cos(degree/180*PI);


  for (i =0; i< 4; i++)
    tmpmat[i][3] = matrix[i][3];

  for (i=0; i< 4; i++) 
    for (j=0; j<4; j++)
      matrix[i][j] = tmpmat[i][j];

}
void myMatMultRotZ(GLfloat degree, GLfloat matrix[4][4])
{
  GLfloat tmpmat[4][4];
  int i, j;


  for (i = 0; i<4; i++)
    tmpmat[i][0] = matrix[i][0] * cos(degree/180*PI) + matrix[i][1] * -sin(degree/180*PI);
  
  for (i = 0; i<4; i++)
    tmpmat[i][1] = matrix[i][0] * sin(degree/180*PI) + matrix[i][1] * cos(degree/180*PI);

  for (i =0; i< 4; i++)
    tmpmat[i][2] = matrix[i][2];

  for (i =0; i< 4; i++)
    tmpmat[i][3] = matrix[i][3];

  for (i=0; i< 4; i++) 
    for (j=0; j<4; j++)
      matrix[i][j] = tmpmat[i][j];

}

void myMatMultScale(GLfloat x, GLfloat y, GLfloat z, GLfloat matrix[4][4])
{
  GLfloat tmpmat[4][4];
  int i, j;

  for (i = 0; i<4; i++)
    tmpmat[i][0] = matrix[i][0] * x;
  
  for (i = 0; i<4; i++)
    tmpmat[i][1] = matrix[i][1] * y;

  for (i =0; i< 4; i++)
    tmpmat[i][2] = matrix[i][2] * z;

  for (i =0; i< 4; i++)
    tmpmat[i][3] = matrix[i][3];

  for (i=0; i< 4; i++) 
    for (j=0; j<4; j++)
      matrix[i][j] = tmpmat[i][j];
}

void myMatMultTranslate(GLfloat x, GLfloat y, GLfloat z, GLfloat matrix[4][4])
{
  GLfloat tmpmat[4][4];
  int i, j;

  for (i = 0; i<4; i++)
    tmpmat[i][0] = matrix[i][0] + matrix[i][3]*x;
  
  for (i = 0; i<4; i++)
    tmpmat[i][1] = matrix[i][1] + matrix[i][3]*y;

  for (i =0; i< 4; i++)
    tmpmat[i][2] = matrix[i][2] + matrix[i][3]*z;

  for (i =0; i< 4; i++)
    tmpmat[i][3] = matrix[i][3];

  for (i=0; i< 4; i++) 
    for (j=0; j<4; j++)
      matrix[i][j] = tmpmat[i][j];
}


BOOL COpenGLView::SetupPixelFormat()
{
  static PIXELFORMATDESCRIPTOR pfd = 
  {
    sizeof(PIXELFORMATDESCRIPTOR),  // size of this pfd
    1,                              // version number
    PFD_DRAW_TO_WINDOW |            // support window
    PFD_SUPPORT_OPENGL |          // support OpenGL
    PFD_DOUBLEBUFFER,             // double buffered
    PFD_TYPE_RGBA,                  // RGBA type
    24,                             // 24-bit color depth
    0, 0, 0, 0, 0, 0,               // color bits ignored
    0,                              // no alpha buffer
    0,                              // shift bit ignored
    0,                              // no accumulation buffer
    0, 0, 0, 0,                     // accum bits ignored
    //        32,                             // 32-bit z-buffer
    16, // NOTE: 16-bit is faster than a 32-bit z-buffer
    0,                              // no stencil buffer
    0,                              // no auxiliary buffer
    PFD_MAIN_PLANE,                 // main layer
    0,                              // reserved
    0, 0, 0                         // layer masks ignored
  };
  int pixelformat;

  if ( 0 == (pixelformat = ::ChoosePixelFormat(m_pDC->GetSafeHdc(), &pfd)) )
    {
      SetError(2);
      return FALSE;
    }

  if ( FALSE == ::SetPixelFormat(m_pDC->GetSafeHdc(), pixelformat, &pfd) )
    {
      SetError(3);
      return FALSE;
    }

  return TRUE;
}

void COpenGLView::OnDestroy() 
{
  CView::OnDestroy();
	
  // TODO: Add your message handler code here

  if ( FALSE == ::wglDeleteContext( m_hRC ) )
    {
      SetError(6);
    }

  if ( m_pDC )
    {
      delete m_pDC;
    }
}


BOOL COpenGLView::OnEraseBkgnd(CDC* pDC) 
{
  // TODO: Add your message handler code here and/or call default
	
  //	return CView::OnEraseBkgnd(pDC);
  return TRUE; // tell Windows not to erase the background
}

/*
void myReshape(int w, int h)
{
    glViewport(0, 0, w, h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(65.0, (GLfloat) w/(GLfloat) h, 1.0, 50.0);
    glMatrixMode(GL_MODELVIEW);
    /*    glLoadIdentity();
    glTranslatef (0.0, 0.0, -5.0); */ /* viewing transform  
} */

void COpenGLView::OnSize(UINT nType, int cx, int cy) 
{
  CView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
  GLdouble aspect_ratio; // width/height ratio
	
  if ( 0 >= cx || 0 >= cy )
    {
      return;
    }


  SetupViewport( cx, cy );

  // select the projection matrix and clear it
  ::glMatrixMode(GL_PROJECTION);
  ::glLoadIdentity();

  // compute the aspect ratio
  // this will keep all dimension scales equal
  aspect_ratio = (GLdouble)cx/(GLdouble)cy;

  // select the viewing volumn
  SetupViewingFrustum( aspect_ratio );
	
  // switch back to the modelview matrix
  ::glMatrixMode(GL_MODELVIEW);
  ::glLoadIdentity();

  // now perform any viewing transformations
  SetupViewingTransform();
	
  //myReshape(cx, cy);

}

 /////////////////////////////////////////////////////////////////////////////
// COpenGLView helper functions

BOOL COpenGLView::SetupViewport( int cx, int cy )
{
	// select the full client area
    ::glViewport(0, 0, cx, cy);

	return TRUE;
}

BOOL COpenGLView::SetupViewingFrustum( GLdouble aspect_ratio )
{
	// select a default viewing volumn
  //    ::gluPerspective(65.0f, aspect_ratio, .1f, 100.0f);
    ::gluPerspective(55.0f, aspect_ratio, .1f, 300.0f);
    return TRUE;
}


BOOL COpenGLView::SetupViewingTransform()
{
	// select a default viewing transformation
	// of a 20 degree rotation about the X axis
	// then a -5 unit transformation along Z
  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
  ::glTranslatef( 0.0f, 0.0f, -5.0f );
  ::glRotatef( 20.0f, 1.0f, 0.0f, 0.0f );

  gluLookAt(pDoc->m_camFrom[0], pDoc->m_camFrom[1], pDoc->m_camFrom[2],
	    0.0,0.0,0.0,
	    0,1,0);
	
  return TRUE;
}

void CalPos(GLfloat cpt[4][3], GLfloat pos, GLfloat *output)
{
  output[0] = cpt[0][0]*(1-pos)*(1-pos)*(1-pos) +
              cpt[1][0]*3*pos*(1-pos)*(1-pos) +
              cpt[2][0]*3*pos*pos*(1-pos)+
              cpt[3][0]*pos*pos*pos;
    
  output[1] = cpt[0][1]*(1-pos)*(1-pos)*(1-pos) +
              cpt[1][1]*3*pos*(1-pos)*(1-pos) +
              cpt[2][1]*3*pos*pos*(1-pos)+
              cpt[3][1]*pos*pos*pos;
    
  output[2] = cpt[0][2]*(1-pos)*(1-pos)*(1-pos) +
              cpt[1][2]*3*pos*(1-pos)*(1-pos) +
              cpt[2][2]*3*pos*pos*(1-pos)+
              cpt[3][2]*pos*pos*pos;
}

void myMult(GLfloat ctpt[3], GLfloat matrix[4][4], GLfloat out[3])
{
  int i;

  for (i = 0; i< 3; i++) 
    out[i] = ctpt[0] * matrix[0][i] + ctpt[1]*matrix[1][i] +ctpt[2]*matrix[2][i] +matrix[3][i];
}


void Normalize(GLfloat v[3])
{
  GLfloat d = sqrt(v[0]*v[0] + v[1]*v[1] + v[2]*v[2]);
  if (d == 0) {
    printf("error");
    return;
  }
  
  v[0] /= d;
  v[1] /= d;
  v[2] /= d;
}


void NormCrossProd(GLfloat v1[3], GLfloat v2[3], GLfloat out[3])
{

  out[0] = v1[1] * v2[2] - v1[2] * v2[1];
  out[1] = v1[2] * v2[0] - v1[0] * v2[2];
  out[2] = v1[0] * v2[1] - v1[2] * v2[0];
  Normalize(out);
}


void myinit(void)
{

  glShadeModel(GL_SMOOTH);
}


BOOL COpenGLView::PreRenderScene()
{
  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
  
  ::glLoadIdentity();
  gluLookAt(pDoc->m_camFrom[0], pDoc->m_camFrom[1], pDoc->m_camFrom[2],
	    0.0,0.0,0.0,
	    0,1,0);

  glTranslatef(0.0,0.0,-5);
  glRotatef(-90, 1.0, 0.0, 0.0); 
  glRotatef(m_rotex, 1.0, 0.0,0.0);
  glRotatef(m_rotey, 0.0, 1.0,0.0);
  glRotatef(m_rotez, 0.0, 0.0,1.0);

  return TRUE;
}


BOOL COpenGLView::RenderScene()
{

    CString strMsgTxt("");
    CString tmpMsgTxt("");
    //    int rev = revolution* 360 / ic;
    int i, j;
    GLfloat lintpt[3];
    GLfloat last1pt[3];
    GLfloat last2pt[3];
    GLfloat v1[3];
    GLfloat v2[3];
    GLfloat norm[3];
    GLfloat mymatrix[4][4];
    GLfloat ctrlpoints[4][3];
    GLfloat ctrlpoints2[4][3];

    int i1, j1;
    int i2, j2;
    GLfloat tmpctrpts[4][3];
    GLfloat lastctrpts[4][3];
    GLfloat lastctrpts2[4][3];

    GLfloat locals = 0.1;
    GLfloat lastx = 0.0;
    GLfloat lasty = 0.0;
    GLfloat lastz = 0.0;
    GLfloat length;
    GLfloat rz;
    GLfloat ry;

    GLfloat x;
    GLfloat y;
    GLfloat light_ambient[] = { 0.5f, 0.5f, 0.5f, 1.0f };
    GLfloat light_diffuse[] = { 1.0f, 1.0f, 1.0f, 1.0f };
    GLfloat light_specular[] = { 1.0f, 1.0f, 1.0f, 1.0f };
    //    GLfloat light_pos3[] = { 10.0f, 50.0f,10.0f, 0.0f };

    COpenGLViewClassDoc* pDoc = GetDocument();
    ASSERT_VALID(pDoc);

    GLfloat r = pDoc->m_initr;
    GLfloat z = pDoc->m_initz;    

  glClearColor(0.0, 0.0, 0.0, 1.0);

  glClear(GL_COLOR_BUFFER_BIT);
  
  ::glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);
  ::glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
  ::glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular);
  //  ::glLightfv(GL_LIGHT0, GL_POSITION, light_pos3);


  if (pDoc->m_light) {
    ::glEnable(GL_LIGHTING);
    ::glEnable(GL_LIGHT0); 
  } else {
    ::glDisable(GL_LIGHTING);
    ::glDisable(GL_LIGHT0); 
  }    
      

  ::glEnable(GL_AUTO_NORMAL);
  ::glEnable(GL_NORMALIZE);
  ::glDepthFunc(GL_LEQUAL);
  ::glEnable(GL_DEPTH_TEST);

  if (pDoc->m_flat)
    ::glShadeModel (GL_FLAT);
  else
    ::glShadeModel (GL_SMOOTH);

  GLfloat material_ambient[]   = { 0.2f, 0.2f, 0.2f, 1.0f };
  GLfloat material_diffuse[]   = { 0.1f, 0.5f, 0.8f, 1.0f };
  GLfloat material_specular[]  = { 1.0f, 1.0f, 1.0f, 1.0f };
  GLfloat material_shininess[] = { 100.0f };
  GLfloat material_emission[4]; 

  ::glMaterialfv(GL_FRONT, GL_AMBIENT,   material_ambient );
  ::glMaterialfv(GL_FRONT, GL_DIFFUSE,   material_diffuse );
  ::glMaterialfv(GL_FRONT, GL_SPECULAR,  material_specular );
  ::glMaterialfv(GL_FRONT, GL_SHININESS, material_shininess );

  if (pDoc->m_mat) {
    material_emission[0] = (GLfloat)pDoc->m_spinr/100;
    material_emission[1] = (GLfloat)pDoc->m_sping/100;
    material_emission[2] = (GLfloat)pDoc->m_spinb/100;
    material_emission[3] = 1.0f;
  } else {
    material_emission[0] = 0.0;
    material_emission[1] = 0.0;
    material_emission[2] = 0.0;
    material_emission[3] = 1.0f;
  }
  ::glMaterialfv(GL_FRONT, GL_EMISSION,  material_emission );

  glPushMatrix();

  //  glRotatef(180, 0.0, 0.0, 1.0);

  for (int k =0; k<4; k++) {
    ctrlpoints[k][0] = pDoc->GetXCoor(k);
    ctrlpoints[k][1] = 0.0;
    ctrlpoints[k][2] = pDoc->GetYCoor(k);
  }

  for (k =0; k<4; k++) {
    ctrlpoints2[k][0] = pDoc->GetXCoor((3+k)%6);
    ctrlpoints2[k][1] = 0.0;
    ctrlpoints2[k][2] = pDoc->GetYCoor((3+k)%6);
  }

    
    r = pDoc->m_initr;
    z = pDoc->m_initz;
    locals = 0.1;
    for (i = 0; i< pDoc->m_rev; i++) {
      x = r*cos((GLfloat) (i*pDoc->m_increment)*2*PI/360);
      y = r*sin((GLfloat) (i*pDoc->m_increment)*2*PI/360);
      
      length = sqrt((x-lastx) *(x-lastx) + (y-lasty) *(y-lasty) + (z-lastz) *(z-lastz));

      /*      if (x > lastx)
	ry = atan((x-lastx)/(y-lasty)) *180/PI;
      else {
	if (y > lasty)
	  ry = 180 + atan((x-lastx)/(y-lasty)) *180/PI;
	else */

      ry = atan((x-lastx)/(y-lasty)) *180/PI;

      if ((y-lasty) < 0)
	ry += 180;

      //      if (y>0)
      //	ry = -ry;

      //      ry = (i*ic)*PI/180;

      rz = acos(sqrt((x-lastx)*(x-lastx) + (y-lasty) * (y-lasty))/length);

	/*tmpMsgTxt.Format("i %d, lastx: %f, x: %f, lasty: %f, y: %f, ry %f, rz %f\n",i, lastx, x, lasty, y, ry, rz);
	strMsgTxt += tmpMsgTxt; */

      //      strMsgTxt.Format("i %d, lastx: %f, x: %f, lasty: %f, y: %f, ry %f, rz %f\n",i, lastx, x, lasty, y, ry, rz);

			   
      //      glPushMatrix();
      // initialize matrix 
      for (i1=0; i1<4; i1++)
	for (j1=0; j1<4; j1++) {
	  if (i1 == j1)
	    mymatrix[i1][j1] = 1.0;
	  else 
	    mymatrix[i1][j1] = 0.0;
	}
      
      if (i==pDoc->m_rev-1) {
	for (i1=0; i1<4; i1++) {
	    tmpMsgTxt.Format("identity:\n%f %f %f %f\n", mymatrix[i1][0],
			     mymatrix[i1][1],mymatrix[i1][2],
			     mymatrix[i1][3]);

	    strMsgTxt += tmpMsgTxt;
	}
      }

      //      myMatMultScale(locals, locals, locals, mymatrix);
      /*      if (tf) {
	myMatMultRotY(rz * 360/2/PI, mymatrix);
      } else {
      } */
      //      myMatMultRotX(-rz * 360/2/PI, mymatrix);

      if (i==pDoc->m_rev-1) {
	for (i1=0; i1<4; i1++) {
	  tmpMsgTxt.Format("Rz:\n%f %f %f %f\n", mymatrix[i1][0],
			     mymatrix[i1][1],mymatrix[i1][2],
			     mymatrix[i1][3]);
	    strMsgTxt += tmpMsgTxt;
	}
      }
      //      myMatMultRotY(ry, mymatrix);
      myMatMultRotZ(i*pDoc->m_increment,mymatrix);

      if (i==pDoc->m_rev-1) {
	for (i1=0; i1<4; i1++) {
	    tmpMsgTxt.Format("Rz:\n%f %f %f %f\n", mymatrix[i1][0],
			     mymatrix[i1][1],mymatrix[i1][2],
			     mymatrix[i1][3]);
	    strMsgTxt += tmpMsgTxt;
	}
      }

      myMatMultScale(locals, locals, locals, mymatrix);
      if (i==pDoc->m_rev-1) {
	for (i1=0; i1<4; i1++) {
	    tmpMsgTxt.Format("Scale:\n%f %f %f %f\n", mymatrix[i1][0],
			     mymatrix[i1][1],mymatrix[i1][2],
			     mymatrix[i1][3]);
	    strMsgTxt += tmpMsgTxt;
	}
      }

      myMatMultTranslate(x,y,z, mymatrix);
      if (i==pDoc->m_rev-1) {
	for (i1=0; i1<4; i1++) {
	    tmpMsgTxt.Format("Translate:\n%f %f %f %f\n", mymatrix[i1][0],
			     mymatrix[i1][1],mymatrix[i1][2],
			     mymatrix[i1][3]);
	    strMsgTxt += tmpMsgTxt;
	}
      }
      
      /*
      glTranslatef(x, y, z);
      glRotatef(ry, 0.0, 0.0, 1.0);
      glRotatef(rz * 360/2/PI, 0.0, 1.0, 0.0);
      glScalef(locals, locals, locals); */

      glBegin(pDoc->m_solid);
       for (i1 = 0; i1 < 4; i1++) {
	 myMult(ctrlpoints[i1], mymatrix, tmpctrpts[i1]);
       }
       if (i==(pDoc->m_rev-1)) {
	 tmpMsgTxt.Format("i %d, lastx: %f, x: %f, lasty: %f, y: %f, z: %f, ry %f, rz %f scale %f\n %f, %f, %f\n %f, %f, %f\n %f, %f, %f\n %f, %f, %f",i, lastx, x, lasty, y, z,ry, rz,locals,tmpctrpts[0][0],tmpctrpts[0][1],tmpctrpts[0][2],tmpctrpts[1][0],tmpctrpts[1][1],tmpctrpts[1][2],tmpctrpts[2][0],tmpctrpts[2][1],tmpctrpts[2][2],tmpctrpts[3][0],tmpctrpts[3][1],tmpctrpts[3][2]);
       }

       strMsgTxt +=tmpMsgTxt;

      for (j = 0; j<=pDoc->m_points; j++) {
	CalPos(tmpctrpts,(GLfloat)j/pDoc->m_points,lintpt);

	if (j) {
	  for (i2=0; i2<3; i2++) {
	    v1[i2] = last1pt[i2]-lintpt[i2];
	    v2[i2] = last2pt[i2]-lintpt[i2];
	  }
	  
	  /*	  if (x > 0 || lastx > 0)
		  NormCrossProd(v1, v2, norm);
		  else
		  NormCrossProd(v2,v1, norm); */

	  NormCrossProd(v1, v2, norm);

	  glNormal3fv(norm);
	} else 
	  glNormal3f(1.0,1.0,1.0);

	glColor3f(1.0f, 1.0f, 1.0f);
	glVertex3fv(lintpt);
	
	for (i2=0; i2<3; i2++) {
	  last1pt[i2] = lintpt[i2];
	}
	if (i) {
	  CalPos(lastctrpts,(GLfloat)j/pDoc->m_points,lintpt);
	  //	  glColor3f(0.0f, 0.0f, 0.5f);
	  if (j) {
	    for (i2=0; i2<3; i2++) {
	      v1[i2] = last1pt[i2]-lintpt[i2];
	      v2[i2] = last2pt[i2]-lintpt[i2];
	    }
	  
	    /*	  if (x > 0 || lastx > 0)
		  NormCrossProd(v1, v2, norm);
		  else
		  NormCrossProd(v2,v1, norm); */
	    NormCrossProd(v1, v2, norm);
	    glNormal3fv(norm);
	    for (i2=0; i2<3; i2++) {
	      last2pt[i2] = lintpt[i2];
	    }
	  } else
	    glNormal3f(1.0,1.0,1.0);


	  glColor3f(0.5f, 0.0f, 0.5f);
	  glVertex3fv(lintpt);
	}
      }
      for (i1=0; i1<4; i1++)
	for (j1=0; j1<3; j1++)
	  lastctrpts[i1][j1] = tmpctrpts[i1][j1];
      
      for (i1 = 0; i1 < 4; i1++) 
	myMult(ctrlpoints2[i1], mymatrix, tmpctrpts[i1]);

      for (j = 1; j<=pDoc->m_points; j++) {
	CalPos(tmpctrpts,(GLfloat)j/pDoc->m_points,lintpt);

	for (i2=0; i2<3; i2++) {
	  v1[i2] = last1pt[i2]-lintpt[i2];
	  v2[i2] = last2pt[i2]-lintpt[i2];
	}
	  
	/*	if (x > 0 || lastx > 0)
	  NormCrossProd(v1, v2, norm);
	  else
	  NormCrossProd(v2,v1, norm); */

	NormCrossProd(v1, v2, norm);
	glNormal3fv(norm);

	glColor3f(1.0f, 1.0f, 1.0f);
	if (pDoc->m_loop)
	  glVertex3fv(lintpt);
	
	for (i2=0; i2<3; i2++) {
	  last1pt[i2] = lintpt[i2];
	}
	if (i) {
	  CalPos(lastctrpts2,(GLfloat)j/pDoc->m_points,lintpt);
	  if (j) {
	    for (i2=0; i2<3; i2++) {
	      v1[i2] = last1pt[i2]-lintpt[i2];
	      v2[i2] = last2pt[i2]-lintpt[i2];
	    }
	  
	    /*	    if (x > 0 || lastx > 0)
		    NormCrossProd(v1, v2, norm);
		    else
	      NormCrossProd(v2,v1, norm); */
	    NormCrossProd(v1, v2, norm);
	    glNormal3fv(norm);
	    for (i2=0; i2<3; i2++) {
	      last2pt[i2] = lintpt[i2];
	    }
	  }
	  glColor3f(0.5f, 0.0f, 0.5f);
	  if (pDoc->m_loop)
	    glVertex3fv(lintpt);
	}      
      }
      for (i1=0; i1<4; i1++)
	for (j1=0; j1<3; j1++)
	  lastctrpts2[i1][j1] = tmpctrpts[i1][j1];
      glEnd();

      //      glPopMatrix();
      lastx = x;
      lasty = y;
      lastz = z;
      r *= pDoc->m_lamdar;
      z *= pDoc->m_lamdar;
      locals *= pDoc->m_scalex;
      

    }
    if (tf) {
      /*strMsgTxt.Format("revolution: %d, ic %d, localscale %f, initi %f",
		       revolution, ic, localscale, initi); */
      AfxMessageBox(strMsgTxt); 
    }    
    //    glCallList(BEZIER_LINE);

    glPopMatrix();

    glFlush();
    return TRUE;
}	


// Draw a square surface that looks like a
// black and white checkerboard
void COpenGLView::RenderStockScene()
{
	// define all vertices   X     Y     Z
	GLfloat v0[3], v1[3], v2[3], v3[3], delta;
	int color = 0;

	delta = 0.5f;

	// define the two colors
	GLfloat color1[3] = { 0.9f, 0.9f, 0.9f };
 	GLfloat color2[3] = { 0.05f, 0.05f, 0.05f };

	v0[1] = v1[1] = v2[1] = v3[1] = 0.0f;

	::glBegin( GL_QUADS );

	for ( int x = -5 ; x <= 5 ; x++ )
		{
		for ( int z = -5 ; z <= 5 ; z++ )
			{
			::glColor3fv( (color++)%2 ? color1 : color2 );
		
			v0[0] = 0.0f+delta*z;
			v0[2] = 0.0f+delta*x;

			v1[0] = v0[0]+delta;
			v1[2] = v0[2];

			v2[0] = v0[0]+delta;
			v2[2] = v0[2]+delta;

			v3[0] = v0[0];
			v3[2] = v0[2]+delta;

			::glVertex3fv( v0 );
			::glVertex3fv( v1 );
			::glVertex3fv( v2 );
			::glVertex3fv( v3 );
			}
		}
	::glEnd();	
	
}


/////////////////////////////////////////////////////////////////////////////
// CMyView

IMPLEMENT_DYNCREATE(CMyView, COpenGLView)


// Draw a square surface of red and blue triangles
// all touching the origin.
void CMyView::RenderStockScene( )
{
	// define all vertices   X     Y     Z
	GLfloat surface0[3] = { 0.0f, 0.0f, 0.0f };
	GLfloat surface1[3] = {+5.0f, 0.0f, 0.0f };
	GLfloat surface2[3] = {+5.0f, 0.0f,-5.0f };
	GLfloat surface3[3] = { 0.0f, 0.0f,-5.0f };
	GLfloat surface4[3] = {-5.0f, 0.0f,-5.0f };
	GLfloat surface5[3] = {-5.0f, 0.0f, 0.0f };
	GLfloat surface6[3] = {-5.0f, 0.0f,+5.0f };
	GLfloat surface7[3] = { 0.0f, 0.0f,+5.0f };
	GLfloat surface8[3] = {+5.0f, 0.0f,+5.0f };
	GLfloat surface9[3] = {+5.0f, 0.0f, 0.0f };

	// define the two colors
	GLfloat color1[3] = { 0.5f, 0.0f, 0.0f };
 	GLfloat color2[3] = { 0.0f, 0.0f, 0.5f };

	::glBegin( GL_TRIANGLES );
		::glColor3fv( color1 );
		::glVertex3fv( surface0 );
		::glVertex3fv( surface1 );
		::glVertex3fv( surface2 );
		::glColor3fv( color2 );
		::glVertex3fv( surface0 );
		::glVertex3fv( surface2 );
		::glVertex3fv( surface3 );
		::glColor3fv( color1 );
		::glVertex3fv( surface0 );
		::glVertex3fv( surface3 );
		::glVertex3fv( surface4 );
		::glColor3fv( color2 );
		::glVertex3fv( surface0 );
		::glVertex3fv( surface4 );
		::glVertex3fv( surface5 );
		::glColor3fv( color1 );
		::glVertex3fv( surface0 );
		::glVertex3fv( surface5 );
		::glVertex3fv( surface6 );
		::glColor3fv( color2 );
		::glVertex3fv( surface0 );
		::glVertex3fv( surface6 );
		::glVertex3fv( surface7 );
		::glColor3fv( color1 );
		::glVertex3fv( surface0 );
		::glVertex3fv( surface7 );
		::glVertex3fv( surface8 );
		::glColor3fv( color2 );
		::glVertex3fv( surface0 );
		::glVertex3fv( surface8 );
		::glVertex3fv( surface9 );
	::glEnd();	
	
}


void COpenGLView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
  COpenGLViewClassDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
	// TODO: Add your message handler code here and/or call default
  switch(nChar) {
    /*  case VK_LEFT:  ic += 1; OnDraw(m_pDC);
	break;
    case VK_RIGHT: ic -= 1; OnDraw(m_pDC);
    break; */
  case VK_LEFT:  m_rotey +=10.0; OnDraw(m_pDC);
    break;
  case VK_RIGHT: m_rotey -=10.0; OnDraw(m_pDC);
    break; 
  case VK_UP: m_rotex += 10.0; OnDraw(m_pDC);
    break;
  case VK_DOWN: m_rotex -= 10.0; OnDraw(m_pDC);
    break;
    /*  case VK_HOME: localscale += 0.001; OnDraw(m_pDC);
	break;
	case VK_END: 
	tf = !tf;
	break; */
  case VK_HOME: m_rotez +=10.0; OnDraw(m_pDC);
    break;
  case VK_END:  m_rotez -= 10.0; OnDraw(m_pDC);
    break; 
  case VK_INSERT: pDoc->m_initz += 0.01; OnDraw(m_pDC);
    break;
  case VK_DELETE: pDoc->m_initz -= 0.01; OnDraw(m_pDC);  
    break;
  case VK_PRIOR: pDoc->m_initr -= 0.1; OnDraw(m_pDC);
    break;
  case VK_NEXT: pDoc->m_initr += 0.1;  OnDraw(m_pDC);
    break;
  default:
    break;
  }

}


void COpenGLView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
}
