// COpenGLView.h : interface of the COpenGLView class
//
/////////////////////////////////////////////////////////////////////////////


// Include the OpenGL headers
#include "gl\gl.h"
#include "gl\glu.h"
#include "gl\glaux.h"

class ShellDialog;
class CShDialog;
class COpenGLViewClassDoc;

class COpenGLView : public CView
{
protected: // create from serialization only
	COpenGLView();
	DECLARE_DYNCREATE(COpenGLView)

// Attributes
public:
	COpenGLViewClassDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COpenGLView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:

	virtual ~COpenGLView();
        void RevDown();
        void RevUp();
	void SetSmooth(BOOL t);
	void SetLight(BOOL t);
	void SetPoints(INT t);
	void SetLoop(BOOL t);
	void SetSolid(BOOL t);
	void SetCamX(float t);
	void SetCamY(float t);
	void SetCamZ(float t);

        void SetInitr(float t);
        void SetInitz(float t);
        void SetLamdar(float t);
        void SetRevolution(INT t);
        void SetScalex(float t);
        void SetScaley(float t);
        void SetScalez(float t);
        void SetIncrement(INT t);
        void SetMat(BOOL t);
        void SetRed(INT t);
        void SetGreen(INT t);
        void SetBlue(INT t);

  

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(COpenGLView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	// The following was added

	virtual BOOL SetupPixelFormat( void );
	virtual BOOL SetupViewport( int cx, int cy );
	virtual BOOL SetupViewingFrustum( GLdouble aspect_ratio );
	virtual BOOL SetupViewingTransform( void );
  	virtual BOOL PreRenderScene( void );
 	virtual void RenderStockScene( void );
	virtual BOOL RenderScene( void );
  


private:
	BOOL InitializeOpenGL();
	void SetError( int e );

	void init_surface();

        ShellDialog *m_pDlg;
	HGLRC	m_hRC;
	CDC*	m_pDC;
        GLfloat m_rotex;
        GLfloat m_rotey;
        GLfloat m_rotez;
	static const char* const _ErrorStrings[];
	const char* m_ErrorString;
  

};

#ifndef _DEBUG  // debug version in COpenGLView.cpp
inline COpenGLViewClassDoc* COpenGLView::GetDocument()
   { return (COpenGLViewClassDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyView class definition


class CMyView : public COpenGLView
{
private:

	DECLARE_DYNCREATE(CMyView)

protected:

	virtual void RenderStockScene( void );
	
};

//////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
